/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import { BinaryOpSharedProgram } from './binary_op_shared_webgpu';
import { BinaryOpVec4Program } from './binary_op_vec4_webgpu';
import { BinaryOpProgram } from './binary_op_webgpu';
export declare enum BinaryOpType {
    MUL = 0,
    ADD = 1,
    SUB = 2,
    DIV = 3,
    EQUAL = 4,
    GREATER = 5,
    GREATER_EQUAL = 6,
    LESS = 7,
    LESS_EQUAL = 8,
    NOT_EQUAL = 9,
    SQUARED_DIFFERENCE = 10,
    INT_DIV = 11,
    POW = 12,
    PRELU = 13,
    MAX = 14,
    MIN = 15
}
export declare function getBinaryOpString(type: BinaryOpType, useVec4?: boolean): string;
export declare function getBinaryProgram(op: BinaryOpType, aShape: number[], bShape: number[]): BinaryOpProgram | BinaryOpVec4Program | BinaryOpSharedProgram;
